###########################################################################
## (c) Maria Dascalu 2016
## Start here.

###########################################################################

import oneprog
import allprogs
import sys

###########################################################################
##############                  Set-up                       ##############
###########################################################################

def grabFrom(filename):
    directory = "Results/" + filename
    try:
        fin = open(directory, 'r')
    except:
        print("File does not exist.")
        return

    countList = []
    for line in fin:
        countList.append(line.strip())
    fin.close()

    for entry in countList:
        entry = int(entry)

    return countList


def main():
    print("Counts number of monochromatic arithmetic progressions of length k.")
    if len(sys.argv) == 1:
        print("Minions need commandline input. Run again.")
        return
    elif len(sys.argv) == 5:
        c = sys.argv[1]
        k = sys.argv[2]
        n = sys.argv[3]
        g = sys.argv[4]
    else:
        print("Weird number of arguments (need 4 inputs).")

    try:
        c = int(c)
        k = int(k)
        n = int(n)
        g = int(g)
    except:
        print("Couldn't make things into ints.")
        return

    # set up counts etc
    countList, time_elapsed = allprogs.run(g, n, k, c)
    filename = "progresults_c{}_k{}_n{}.txt".format(c, k, n)
    fin = open("Results/"+filename, "r")
    total = 0
    for line in fin:
        if line[0] != "#" and line[0] != "\n":
            total += 1
    fin.close()
    done = "{} graphs generated at {}, total: {}.".format(g, filename, total)
    print(done)

    arguments = "{}".format("_".join(sys.argv[1:]))
    avgtime = time_elapsed//g
    print("{} time taken on average.".format(avgtime))

main()
