###########################################################################
## (c) Maria Dascalu 2016
## Start here.

###########################################################################

import allgraphs
import onegraph
import populate
import sys
import subprocess as sb

###########################################################################
##############                  Set-up                       ##############
###########################################################################

def grabFrom(filename):
    directory = "Results/" + filename
    try:
        fin = open(directory, 'r')
    except:
        print("File does not exist.")
        return

    countList = []
    for line in fin:
        countList.append(line.strip())
    fin.close()

    for entry in countList:
        entry = int(entry)

    return countList

def grabCat():
    """ () -> string
    Asks user for the category of graph to generate."""
    while True:
        graphcat = input("Which type of graph? Half and half, random, or critical? (h, r, c) ")
        if graphcat == "h":
            return "h"
        elif graphcat == "r":
            return "r"
        elif graphcat == "c":
            return "c"

def main():
    print("RamseyCount generates a number of c-color graphs on n-vertices and counts the number of k-vertex monochromatic subgraphs.")
    if len(sys.argv) == 1:
        print("Minions need commandline input. Run again.")
        return
    elif len(sys.argv) == 6:
        cat = sys.argv[1]
        if cat != "r":
            return
        c = sys.argv[2]
        k = sys.argv[3]
        n = sys.argv[4]
        g = sys.argv[5]

    elif len(sys.argv) == 5:
        cat = sys.argv[1]
        if cat != "h":
            return
        c = 2
        k = sys.argv[2]
        n = sys.argv[3]
        g = sys.argv[4]

    elif len(sys.argv) == 3:
        cat = sys.argv[1]
        if cat != "c":
            return
        c = 2
        k = 5
        n = 43
        g = sys.argv[2]
    else:
        print("Input is broken.")

    try:
        c = int(c)
        k = int(k)
        n = int(n)
        g = int(g)
    except:
        print("Couldn't transform input into integers.")
        return
    # run from commandline
    print(cat, c, k, n, g)
    countList, time_elapsed = allgraphs.run(g, n, k, c, cat)
    filename = "{}esults_c{}_k{}_n{}.txt".format(cat, c, k, n)
    fin = open("Results/"+filename, "r")
    total = 0
    for line in fin:
        if line[0] != "#" and line[0] != "\n":
            total += 1
    fin.close()
    done = "{} graphs generated at {}, total: {}.".format(g, filename, total)
    print(done)
    arguments = "{}".format("_".join(sys.argv[1:]))
    avgtime = time_elapsed//g
    print("{} time taken on average.".format(avgtime))

main()
