import os
# import numpy as np
# import matplotlib.image as mpimg
# import matplotlib.pyplot as plt
# import statistics
# import math

def runHistogram(countList, g, n, k, c, cat):
    mean = statistics.mean(countList)
    minimum = min(countList)
    maximum = max(countList)
    sd = statistics.pstdev(countList)
    num_bins = maximum - minimum

    fig = plt.figure()
    ax = fig.add_subplot(1, 1, 1)
    ax.set_ylabel("Percentage of graphs")
    ax.set_xlabel("Number of {}-vertex monochromatic subgraphs".format(k))
    ax.set_title("Min: {}  Max: {}  $\mu$: {}  $\sigma$: %.2f".format(minimum, maximum, int(mean)) % (sd), fontsize= 12)
    plt.suptitle("{} {}-color, {}-vertex complete graphs".format(g, c, n), fontsize=16, fontweight='bold')
    percentages, bins, patches = ax.hist(countList, num_bins, normed=True, alpha=0.7)
    ax.grid(True)
    name = "Images/img_{}_c{}_k{}_n{}.png".format(cat, c, k, n)
    plt.savefig(name)
    print("Saved histogram to {}".format(name))
    #plt.show()

def cleanData(filename):
    """(str) -> list
    Takes a filename and analyzes the distribution, then prints that to a text file.
    Returns the raw data as a list.
    """
    infile = open("Results/"+filename, "r")
    countList = []
    distribution = {}
    for line in infile:
        if line[0] == "#" or line[0] == "\n":
            continue
        line = int(line.strip())
        if line in distribution:
            distribution[line] += 1
        else:
            distribution[line] = 1
        countList.append(line)

    #print(distribution)
    infile.close()
    outfile = open("CleanResults/clean_" + filename, 'w')
    for numMonK in sorted(distribution.keys()):
        #print(str(numMonK))
        outfile.write(str(numMonK) + " " + str(distribution[numMonK]) + "\n")

    print("Saved cleaned results to {}".format("CleanResults/clean_"+filename))
    return countList

def main():
    print("Will generate images and clean results from the file specified.")
    startfrom = input("Do only: ")
    if startfrom != "":
        start = False
        only = True
    else:
        start = True
    for filename in os.listdir('Results'):
        if filename == startfrom and startfrom != "":
            start = True
        if start:
            countList = cleanData(filename)
            g = len(countList)
            cat = filename[0]
            cindex = filename.find("_c")
            kindex = filename.find("_k")
            nindex = filename.find("_n")
            endindex = filename.find(".")
            c = int(filename[cindex+2:kindex])
            k = int(filename[kindex+2:nindex])
            n = int(filename[nindex+2:endindex])
            #runHistogram(countList, g, n, k, c, cat)
            if only:
                return
        else:
            continue


main()
